## $Id: export.py 9044 2012-07-25 05:36:48Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Exporters for student related stuff.
"""
from kofacustom.nigeria.students.interfaces import (
    INigeriaStudent, INigeriaStudentStudyCourse, INigeriaCourseTicket)
from waeup.kofa.students.export import (
    StudentsExporter, StudentStudyCourseExporter, CourseTicketExporter)
from waeup.kofa.utils.helpers import iface_names

class NigeriaStudentsExporter(StudentsExporter):
    """Exporter for Students.
    """

    #: Fieldnames considered by this exporter
    fields = tuple(sorted(iface_names(
        INigeriaStudent, omit=['loggerInfo']))) + (
        'password', 'state', 'history', 'certcode')

    def mangle_value(self, value, name, context=None):
        if '_result' in name and value:
            value = [eval(entry.to_string()) for entry in value]
        return super(
            NigeriaStudentsExporter, self).mangle_value(
            value, name, context=context)

class NigeriaStudentStudyCourseExporter(StudentStudyCourseExporter):
    """Exporter for StudentStudyCourses.
    """

    #: Fieldnames considered by this exporter
    fields = tuple(
        sorted(iface_names(INigeriaStudentStudyCourse))) + ('student_id',)


class NigeriaCourseTicketExporter(CourseTicketExporter):
    """Exporter for CourseTickets.
    """

    #: Fieldnames considered by this exporter
    fields = tuple(sorted(iface_names(INigeriaCourseTicket) +
        ['level', 'code', 'title', 'credits',
        'passmark', 'semester', 'fcode', 'dcode'])) + ('student_id',)
